<template>
  <div id="product-info-page">
    <AddNewCategory
      v-if="isAdding"
      @add-new-category-event="AddNewCategory"
      @cancel-add-category-event="cancelEditCategoryDetails"
    />
    <ShowListOfCategories
      v-if="isShowing"
      :categories="categories"
      @go-to-add-category="goToAddCategory"
      @delet-category-event="deleteCategory"
      @edit-category-details-event="goToEditcategoryDetails"
    />
    <EditCategoryDetails
      v-if="isEditing"
      :category="category"
      @cancel-edit-category-details-event="cancelEditCategoryDetails"
      @save-new-details-event="SaveChangedDetails"
    />
  </div>
</template>

<script>
import ShowListOfCategories from './ShowListOfCategories.vue'
import EditCategoryDetails from './EditCategoryDetails.vue'
import AddNewCategory from './AddNewCategory.vue'

import API from '@/API.js'
export default {
  name: 'CategoriesConfigurationPage',
  components: {
    ShowListOfCategories,
    EditCategoryDetails,
    AddNewCategory
  },
  props: {},

  data() {
    return {
      idSearched: null,
      categories: null,
      category: [],
      isShowing: true,
      isEditing: false,
      isAdding: false
    }
  },

  mounted() {
    this.isShowing = true
    this.putCategoryDetailsEnData()
  },

  methods: {
    goToAddCategory() {
      this.isShowing = false
      this.isEditing = false
      this.isAdding = true
    },

    async goToEditcategoryDetails(idCategory) {
      this.isShowing = false
      this.isEditing = true
      this.category = await API.loadCategoryDetails(idCategory)
    },
    cancelEditCategoryDetails() {
      this.isShowing = true
      this.isEditing = false
      this.isAdding = false
    },

    async SaveChangedDetails(localCategory) {
      await this.savingEditCategoryDetails(localCategory)
      this.putCategoryDetailsEnData()
      this.cancelEditCategoryDetails()
    },

    async putCategoryDetailsEnData() {
      this.categories = await API.loadCategories()
    },

    monitoringLocalPhoto(localCategory) {
      if (localCategory.image === undefined) {
        localCategory.icons = this.category.icons
      } else {
        localCategory.icons = localCategory.image.dataUrl
      }
    },

    async savingEditCategoryDetails(localCategory) {
      this.monitoringLocalPhoto(localCategory)
      let idSearched = this.idSearched
      await API.savingEditCategoryDetails(idSearched, localCategory)
    },

    async AddNewCategory(newCategory) {
      await API.saveNewCategoryDetails(newCategory)
      this.cancelEditCategoryDetails()
      await this.putCategoryDetailsEnData()
    },
    async deleteCategory(idCategory) {
      await API.deleteCategory(idCategory)
      this.cancelEditCategoryDetails()
      await this.putCategoryDetailsEnData()
    }
  }
}
</script>

<style scoped>
#product_details {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
}
</style>
